## lua-luv 1.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if(POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW) # faster evaluation of variable references
endif()

project (luv C ASM)

set(LUV_VERSION_MAJOR 1)
set(LUV_VERSION_MINOR 9)
set(LUV_VERSION_PATCH 1)
set(LUV_VERSION ${LUV_VERSION_MAJOR}.${LUV_VERSION_MINOR}.${LUV_VERSION_PATCH})

option(BUILD_MODULE "Build as module" ON)
option(BUILD_SHARED_LIBS "Build shared library" OFF)
option(WITH_SHARED_LIBUV "Link to a shared libuv library instead of static linking" OFF)

if (MINGW)
  add_definitions(-D_WIN32_WINNT=0x0600)
endif (MINGW)

if (NOT WITH_LUA_ENGINE)
  set(WITH_LUA_ENGINE "LuaJIT"
    CACHE STRING "Link to LuaJIT or PUC Lua" FORCE)
  set_property(CACHE WITH_LUA_ENGINE
    PROPERTY STRINGS  "Lua;LuaJIT")
endif (NOT WITH_LUA_ENGINE)

if (NOT LUA_BUILD_TYPE)
  set(LUA_BUILD_TYPE "Static"
    CACHE STRING "Build Lua/LuaJIT as static, dynamic libary, or use system one" FORCE)
  set_property(CACHE LUA_BUILD_TYPE
    PROPERTY STRINGS  "Static;Dynamic;System")
endif (NOT LUA_BUILD_TYPE)

if (WITH_LUA_ENGINE STREQUAL Lua)
  if (NOT WIN32)
    add_definitions(-DLUA_USE_DLOPEN)
  endif (NOT WIN32)
  set(USE_LUAJIT OFF)
else ()
  set(USE_LUAJIT ON)
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

if (WITH_SHARED_LIBUV)
  find_package(Libuv)
  if (LIBUV_FOUND)
    include_directories(${LIBUV_INCLUDE_DIR})
  endif (LIBUV_FOUND)
else (WITH_SHARED_LIBUV)
  include(deps/uv.cmake)
  if (BUILD_MODULE)
    add_definitions( -DBUILDING_UV_SHARED )
  endif (BUILD_MODULE)
  set(LIBUV_LIBRARIES uv)
endif (WITH_SHARED_LIBUV)

if (LUA)
  MESSAGE(STATUS "Lua: using information from luarocks")

  MESSAGE(STATUS "LUA_LIBDIR: " ${LUA_LIBDIR})
  MESSAGE(STATUS "LUA_INCDIR: " ${LUA_INCDIR})
  MESSAGE(STATUS "LUA: " ${LUA})

  SET(LUA_EXECUTABLE "${LUA}")
  SET(LUA_INCLUDE_DIR "${LUA_INCDIR}")
  SET(LUA_PACKAGE_PATH "${LUADIR}")
  SET(LUA_PACKAGE_CPATH "${LIBDIR}")

  SET(INSTALL_LIB_DIR ${LIBDIR})

  GET_FILENAME_COMPONENT(LUA_EXEC_NAME ${LUA_EXECUTABLE} NAME_WE)
  IF(LUA_EXEC_NAME STREQUAL "luajit")
  FIND_LIBRARY(LUA_LIBRARIES
    NAMES luajit libluajit
    PATHS ${LUA_LIBDIR}
    NO_DEFAULT_PATH)
  ELSEIF(LUA_EXEC_NAME STREQUAL "lua")
    FIND_LIBRARY(LUA_LIBRARIES
      NAMES lua lua53 lua52 lua51 liblua liblua53 liblua52 liblua51
      PATHS ${LUA_LIBDIR}
      NO_DEFAULT_PATH)
  ENDIF()
  MESSAGE(STATUS "Lua library: ${LUA_LIBRARIES}")

  include_directories(${LUA_INCLUDE_DIR})
else (LUA)
  if (LUA_BUILD_TYPE STREQUAL System)
    if (USE_LUAJIT)
      find_package(LuaJIT)
      if (LUAJIT_FOUND)
        include_directories(${LUAJIT_INCLUDE_DIR})
        link_directories(${LUAJIT_LIBRARIES})
      endif (LUAJIT_FOUND)
    else (USE_LUAJIT)
      find_package(Lua)
      if (LUA_FOUND)
        include_directories(${LUA_INCLUDE_DIR})
      endif (LUA_FOUND)
    endif (USE_LUAJIT)

  else (LUA_BUILD_TYPE STREQUAL System)
    if (LUA_BUILD_TYPE STREQUAL Static)
      SET(WITH_SHARED_LUA OFF)
    else (LUA_BUILD_TYPE STREQUAL Static)
      SET(WITH_SHARED_LUA ON)
    endif (LUA_BUILD_TYPE STREQUAL Static)
    if (USE_LUAJIT)
      include(deps/luajit.cmake)
      include_directories(deps/luajit/src)
      set(LUAJIT_LIBRARIES luajit-5.1)
    else(USE_LUAJIT)
      include(deps/lua.cmake)
      include_directories(deps/lua/src)
    endif (USE_LUAJIT)
  endif (LUA_BUILD_TYPE STREQUAL System)
endif (LUA)

if (BUILD_MODULE)
  add_library(luv MODULE src/luv.c)
  set_target_properties(luv PROPERTIES PREFIX "")
else (BUILD_MODULE)
  add_library(luv src/luv.c)
  if (BUILD_SHARED_LIBS)
    set_target_properties(luv
      PROPERTIES VERSION ${LUV_VERSION} SOVERSION ${LUV_VERSION_MAJOR})
  endif (BUILD_SHARED_LIBS)
endif (BUILD_MODULE)

if(APPLE)
  set(CMAKE_SHARED_MODULE_CREATE_C_FLAGS
    "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -flat_namespace -undefined suppress"
  )
  # execute_process(COMMAND which luajit OUTPUT_VARIABLE LUAJIT)
  # set(CMAKE_SHARED_MODULE_CREATE_C_FLAGS
  #   "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -bundle_loader ${LUAJIT}"
  # )
endif()

if(WIN32)
  add_definitions(-DLUA_BUILD_AS_DLL -DLUA_LIB)
  if (LUA)
    target_link_libraries(luv ${LIBUV_LIBRARIES} ${LUA_LIBRARIES})
  else (LUA)
    if (USE_LUAJIT)
      target_link_libraries(luv ${LIBUV_LIBRARIES} ${LUAJIT_LIBRARIES})
    else (USE_LUAJIT)
      if (LUA_BUILD_TYPE STREQUAL System)
          target_link_libraries(luv ${LIBUV_LIBRARIES} ${LUA_LIBRARIES})
      else (LUA_BUILD_TYPE STREQUAL System)
          target_link_libraries(luv ${LIBUV_LIBRARIES} lualib)
      endif (LUA_BUILD_TYPE STREQUAL System)
    endif (USE_LUAJIT)
  endif (LUA)
  # replace /MD to /MT to avoid link msvcr*.dll
  set(CompilerFlags
    CMAKE_C_FLAGS
    CMAKE_C_FLAGS_DEBUG
    CMAKE_C_FLAGS_MINSIZEREL
    CMAKE_C_FLAGS_RELWITHDEBINFO
    CMAKE_C_FLAGS_RELEASE)
  foreach(CompilerFlag ${CompilerFlags})
    string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
  endforeach()
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
  target_link_libraries(luv ${LIBUV_LIBRARIES} rt)
else()
  target_link_libraries(luv ${LIBUV_LIBRARIES})
endif()

if (NOT LUA)
  if (BUILD_MODULE)
    if (WIN32)
      set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
    else (WIN32)
      set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib/lua/${LUA_VERSION_MAJOR}.${LUA_VERSION_MINOR}")
    endif (WIN32)
  else (BUILD_MODULE)
    set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
      CACHE PATH "Installation directory for libraries")
    set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include/luv"
      CACHE PATH "Installation directory for headers")
  endif (BUILD_MODULE)
endif ()

if (CMAKE_INSTALL_PREFIX)
  install(TARGETS luv
    ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
    LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
  )
  if (NOT BUILD_MODULE)
    install(
      FILES src/luv.h src/util.h src/lhandle.h src/lreq.h
      DESTINATION "${INSTALL_INC_DIR}"
    )
  endif (NOT BUILD_MODULE)
endif (CMAKE_INSTALL_PREFIX)

=== Makefile ===
LUV_TAG=$(shell git describe --tags)

ifdef WITHOUT_AMALG
	CMAKE_OPTIONS+= -DWITH_AMALG=OFF
endif

BUILD_MODULE ?= ON
BUILD_SHARED_LIBS ?= OFF
WITH_SHARED_LIBUV ?= OFF
WITH_LUA_ENGINE ?= LuaJIT
LUA_BUILD_TYPE ?= Static


ifeq ($(WITH_LUA_ENGINE), LuaJIT)
  LUABIN=build/luajit
else
  LUABIN=build/lua
endif

CMAKE_OPTIONS += \
	-DBUILD_MODULE=$(BUILD_MODULE) \
	-DBUILD_SHARED_LIBS=$(BUILD_SHARED_LIBS) \
	-DWITH_SHARED_LIBUV=$(WITH_SHARED_LIBUV) \
	-DWITH_LUA_ENGINE=$(WITH_LUA_ENGINE) \
	-DLUA_BUILD_TYPE=$(LUA_BUILD_TYPE) \

all: luv

deps/libuv/include:
	git submodule update --init deps/libuv

deps/luajit/src:
	git submodule update --init deps/luajit

build/Makefile: deps/libuv/include deps/luajit/src
	cmake -H. -Bbuild ${CMAKE_OPTIONS} -DWITH_AMALG=OFF

luv: build/Makefile
	cmake --build build --config Debug
	ln -sf build/luv.so

clean:
	rm -rf build luv.so

test: luv
	${LUABIN} tests/run.lua

reset:
	git submodule update --init --recursive && \
	  git clean -f -d && \
	  git checkout .

publish-luarocks:
	rm -rf luv-${LUV_TAG}
	mkdir -p luv-${LUV_TAG}/deps
	cp -r src cmake CMakeLists.txt LICENSE.txt README.md docs.md luv-${LUV_TAG}/
	cp -r deps/libuv deps/*.cmake deps/lua_one.c luv-${LUV_TAG}/deps/
	COPYFILE_DISABLE=true tar -czvf luv-${LUV_TAG}.tar.gz luv-${LUV_TAG}
	github-release upload --user luvit --repo luv --tag ${LUV_TAG} \
	  --file luv-${LUV_TAG}.tar.gz --name luv-${LUV_TAG}.tar.gz
	luarocks upload luv-${LUV_TAG}.rockspec --api-key=${LUAROCKS_TOKEN}

## lua-luv 1.9.1-0

=== debian/changelog ===
lua-luv (1.9.1-0-2) unstable; urgency=medium

  * autopkgtest: Add all build-deps so all tests can pass on Debian's CI
  * Tests: disable test-conversions.lua. It does not work properly on
    lua5.1/i386, and this behavior can't be relied on. (Closes: #834461)
  * Add libkvm-dev to Build-Depends for kfreebsd-any (Closes: #834463)

 -- Jason Pleau <jason@jpleau.ca>  Wed, 24 Aug 2016 19:26:41 -0400

lua-luv (1.9.1-0-1) unstable; urgency=medium

  * Initial release (Closes: #829039)

 -- Jason Pleau <jason@jpleau.ca>  Fri, 12 Aug 2016 20:22:40 -0400

=== debian/control ===
Source: lua-luv
Priority: optional
Maintainer: Jason Pleau <jason@jpleau.ca>
Build-Depends: debhelper (>= 9),
               dh-lua,
               libuv1-dev,
               libkvm-dev [kfreebsd-any]
Standards-Version: 3.9.8
Section: interpreters
Homepage: https://github.com/luvit/luv
Vcs-Git: https://anonscm.debian.org/cgit/pkg-lua/lua-luv.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-lua/lua-luv.git

Package: lua-luv
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: libuv bindings for lua
 libuv is a multi-platform support library with a focus on asynchronous I/O.
 .
 This package provides libuv bindings for the Lua programming language.

Package: lua-luv-dev
Section: libdevel
Architecture: any
Depends: lua-luv (= ${binary:Version}), ${misc:Depends}
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Description: libuv bindings for lua
 This package provide the static library for lua-luv

=== debian/tests/control ===
Tests: dh-lua-tests
Restrictions: rw-build-tree
Depends: @, @builddeps@

## lua-luv 1.30.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 project (luv C ASM)
 
 set(LUV_VERSION_MAJOR 1)
-set(LUV_VERSION_MINOR 9)
+set(LUV_VERSION_MINOR 30)
 set(LUV_VERSION_PATCH 1)
 set(LUV_VERSION ${LUV_VERSION_MAJOR}.${LUV_VERSION_MINOR}.${LUV_VERSION_PATCH})
 
@@ -18,6 +18,20 @@
 if (MINGW)
   add_definitions(-D_WIN32_WINNT=0x0600)
 endif (MINGW)
+
+if (WIN32)
+  # replace /MD to /MT to avoid link msvcr*.dll
+  # this needs to be before add_subdirectory calls so that they inherit the modified flags
+  set(CompilerFlags
+    CMAKE_C_FLAGS
+    CMAKE_C_FLAGS_DEBUG
+    CMAKE_C_FLAGS_MINSIZEREL
+    CMAKE_C_FLAGS_RELWITHDEBINFO
+    CMAKE_C_FLAGS_RELEASE)
+  foreach(CompilerFlag ${CompilerFlags})
+    string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
+  endforeach()
+endif ()
 
 if (NOT WITH_LUA_ENGINE)
   set(WITH_LUA_ENGINE "LuaJIT"
@@ -45,16 +59,16 @@
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
 
 if (WITH_SHARED_LIBUV)
-  find_package(Libuv)
-  if (LIBUV_FOUND)
-    include_directories(${LIBUV_INCLUDE_DIR})
-  endif (LIBUV_FOUND)
+  find_package(Libuv REQUIRED)
+  include_directories(${LIBUV_INCLUDE_DIR})
 else (WITH_SHARED_LIBUV)
-  include(deps/uv.cmake)
+  include_directories(deps/libuv/include)
+  add_subdirectory(deps/libuv EXCLUDE_FROM_ALL)
   if (BUILD_MODULE)
     add_definitions( -DBUILDING_UV_SHARED )
   endif (BUILD_MODULE)
-  set(LIBUV_LIBRARIES uv)
+  set(LIBUV_LIBRARIES uv_a)
+  set_target_properties(uv_a PROPERTIES COMPILE_FLAGS "-fPIC")
 endif (WITH_SHARED_LIBUV)
 
 if (LUA)
@@ -77,7 +91,7 @@
     NAMES luajit libluajit
     PATHS ${LUA_LIBDIR}
     NO_DEFAULT_PATH)
-  ELSEIF(LUA_EXEC_NAME STREQUAL "lua")
+  ELSEIF(LUA_EXEC_NAME MATCHES "lua.*")
     FIND_LIBRARY(LUA_LIBRARIES
       NAMES lua lua53 lua52 lua51 liblua liblua53 liblua52 liblua51
       PATHS ${LUA_LIBDIR}
@@ -89,16 +103,12 @@
 else (LUA)
   if (LUA_BUILD_TYPE STREQUAL System)
     if (USE_LUAJIT)
-      find_package(LuaJIT)
-      if (LUAJIT_FOUND)
-        include_directories(${LUAJIT_INCLUDE_DIR})
-        link_directories(${LUAJIT_LIBRARIES})
-      endif (LUAJIT_FOUND)
+      find_package(LuaJIT REQUIRED)
+      include_directories(${LUAJIT_INCLUDE_DIR})
+      link_directories(${LUAJIT_LIBRARIES})
     else (USE_LUAJIT)
-      find_package(Lua)
-      if (LUA_FOUND)
-        include_directories(${LUA_INCLUDE_DIR})
-      endif (LUA_FOUND)
+      find_package(Lua REQUIRED)
+      include_directories(${LUA_INCLUDE_DIR})
     endif (USE_LUAJIT)
 
   else (LUA_BUILD_TYPE STREQUAL System)
@@ -113,7 +123,7 @@
       set(LUAJIT_LIBRARIES luajit-5.1)
     else(USE_LUAJIT)
       include(deps/lua.cmake)
-      include_directories(deps/lua/src)
+      include_directories(deps/lua)
     endif (USE_LUAJIT)
   endif (LUA_BUILD_TYPE STREQUAL System)
 endif (LUA)
@@ -138,6 +148,14 @@
   #   "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -bundle_loader ${LUAJIT}"
   # )
 endif()
+
+if(NOT LUA_COMPAT53_DIR)
+  set(LUA_COMPAT53_DIR deps/lua-compat-5.3)
+endif()
+if(DEFINED ENV{LUA_COMPAT53_DIR})
+  set(LUA_COMPAT53_DIR $ENV{LUA_COMPAT53_DIR})
+endif()
+include_directories(${LUA_COMPAT53_DIR})
 
 if(WIN32)
   add_definitions(-DLUA_BUILD_AS_DLL -DLUA_LIB)
@@ -154,16 +172,6 @@
       endif (LUA_BUILD_TYPE STREQUAL System)
     endif (USE_LUAJIT)
   endif (LUA)
-  # replace /MD to /MT to avoid link msvcr*.dll
-  set(CompilerFlags
-    CMAKE_C_FLAGS
-    CMAKE_C_FLAGS_DEBUG
-    CMAKE_C_FLAGS_MINSIZEREL
-    CMAKE_C_FLAGS_RELWITHDEBINFO
-    CMAKE_C_FLAGS_RELEASE)
-  foreach(CompilerFlag ${CompilerFlags})
-    string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
-  endforeach()
 elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
   target_link_libraries(luv ${LIBUV_LIBRARIES} rt)
 else()
@@ -191,6 +199,14 @@
     LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
   )
   if (NOT BUILD_MODULE)
+    if(UNIX)
+      set(prefix ${CMAKE_INSTALL_PREFIX})
+      set(includedir ${INSTALL_INC_DIR})
+      set(libdir ${INSTALL_LIB_DIR})
+      configure_file(libluv.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libluv.pc @ONLY)
+      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libluv.pc
+        DESTINATION ${INSTALL_LIB_DIR}/pkgconfig)
+    endif()
     install(
       FILES src/luv.h src/util.h src/lhandle.h src/lreq.h
       DESTINATION "${INSTALL_INC_DIR}"

=== Makefile ===
LUV_TAG=$(shell git describe --tags)

ifdef WITHOUT_AMALG
	CMAKE_OPTIONS+= -DWITH_AMALG=OFF
endif

BUILD_MODULE ?= ON
BUILD_SHARED_LIBS ?= OFF
WITH_SHARED_LIBUV ?= OFF
WITH_LUA_ENGINE ?= LuaJIT
LUA_BUILD_TYPE ?= Static
LUA_COMPAT53_DIR ?= deps/lua-compat-5.3

ifeq ($(WITH_LUA_ENGINE), LuaJIT)
  LUABIN=build/luajit
else
  LUABIN=build/lua
endif

CMAKE_OPTIONS += \
	-DBUILD_MODULE=$(BUILD_MODULE) \
	-DBUILD_SHARED_LIBS=$(BUILD_SHARED_LIBS) \
	-DWITH_SHARED_LIBUV=$(WITH_SHARED_LIBUV) \
	-DWITH_LUA_ENGINE=$(WITH_LUA_ENGINE) \
	-DLUA_BUILD_TYPE=$(LUA_BUILD_TYPE) \
	-DLUA_COMPAT53_DIR=$(LUA_COMPAT53_DIR)

ifeq ($(MAKE),mingw32-make)
CMAKE_OPTIONS += -G"MinGW Makefiles"
LUV_EXT ?= .dll
LUV_CP  ?= cp -f
endif

LUV_EXT ?= .so
LUV_CP  ?= ln -sf

all: luv

deps/libuv/include:
	git submodule update --init deps/libuv

deps/luajit/src:
	git submodule update --init deps/luajit

deps/lua-compat-5.3/c-api:
	git submodule update --init deps/lua-compat-5.3

build/Makefile: deps/libuv/include deps/luajit/src deps/lua-compat-5.3/c-api
	cmake -H. -Bbuild ${CMAKE_OPTIONS}

luv: build/Makefile
	cmake --build build --config Debug
	$(LUV_CP) build/luv$(LUV_EXT) luv$(LUV_EXT)

install: luv
	$(MAKE) -C build install

clean:
	rm -rf build luv.so

test: luv
	${LUABIN} tests/run.lua

reset:
	git submodule update --init --recursive && \
	  git clean -f -d && \
	  git checkout .

publish-luarocks:
	github-release upload --user luvit --repo luv --tag ${LUV_TAG} \
	  --file luv-${LUV_TAG}.tar.gz --name luv-${LUV_TAG}.tar.gz
	luarocks upload luv-${LUV_TAG}.rockspec --api-key=${LUAROCKS_TOKEN}

# vim: ts=8 sw=8 noet tw=79 fen fdm=marker

## lua-luv 1.30.1-1

=== debian/changelog ===
lua-luv (1.30.1-1-2) unstable; urgency=medium

  * disable_some_tests.patch: add test-leaks to exceptions, since it's flaky

 -- James McCoy <jamessan@debian.org>  Wed, 30 Oct 2019 21:30:09 -0400

lua-luv (1.30.1-1-1) unstable; urgency=medium

  [ Jason Pleau ]
  * New upstream release
  * Point Vcs-* to salsa.debian.org
  * Add a B-D on debhelper-compat (and remove debian/compat)
  * disable_some_tests.patch: add test-udp to exceptions
  * Update Standards-Version to 4.4.0, no changes
  * Add a Build-Depends on lua-compat53-dev

  [ James McCoy ]
  * Add fix-compat53-include-path.patch, to correct the expected include path
    for lua-compat53-dev's compat-5.3.h
  * debian/lua5.x.dh-lua.conf:
    + Specify LUA_HEADER=src/luv.h so packages can build against the C API
    + Add -Isrc to CLIB_CFLAGS to find the header when building the test app
    + Add libuv1-dev Depends on lua-luv-dev
  * Install all luv header files to /usr/include/lua5.x/luv/
  * Cherry-pick upstream patch, b461b6fa3, to fix the process-stdout test when
    run with dh-lua's app test.
  * Set Rules-Requires-Root: no
  * Mark lua-luv(-dev) Multi-Arch: same
  * Add myself to Uploaders

 -- James McCoy <jamessan@debian.org>  Tue, 29 Oct 2019 07:05:59 -0400

=== debian/control ===
Source: lua-luv
Priority: optional
Maintainer: Jason Pleau <jason@jpleau.ca>
Uploaders: James McCoy <jamessan@debian.org>
Build-Depends: debhelper-compat (= 12),
               dh-lua,
               lua-compat53-dev,
               libuv1-dev,
               libkvm-dev [kfreebsd-any]
Standards-Version: 4.4.0
Section: interpreters
Rules-Requires-Root: no
Homepage: https://github.com/luvit/luv
Vcs-Git: https://salsa.debian.org/lua-team/lua-luv
Vcs-Browser: https://salsa.debian.org/lua-team/lua-luv

Package: lua-luv
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
Provides: ${lua:Provides}
Multi-Arch: same
XB-Lua-Versions: ${lua:Versions}
Description: libuv bindings for lua
 libuv is a multi-platform support library with a focus on asynchronous I/O.
 .
 This package provides libuv bindings for the Lua programming language.

Package: lua-luv-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libuv1-dev, lua-luv (= ${binary:Version}), ${misc:Depends}
Provides: ${lua:Provides}
Multi-Arch: same
XB-Lua-Versions: ${lua:Versions}
Description: libuv bindings for lua
 This package provide the static library for lua-luv

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_configure:
	dh_auto_configure
# Remove usr/include/lua{luaver}/luv.h from dev.install, since all the
# headers get installed to usr/include/lua{luaver}/luv/
	sed -i '/usr\/include\/lua5\.[1-9]\/luv\.h/d' debian/lua-luv-dev.install

## lua-luv 1.36.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,11 +7,12 @@
 project (luv C ASM)
 
 set(LUV_VERSION_MAJOR 1)
-set(LUV_VERSION_MINOR 30)
-set(LUV_VERSION_PATCH 1)
+set(LUV_VERSION_MINOR 36)
+set(LUV_VERSION_PATCH 0)
 set(LUV_VERSION ${LUV_VERSION_MAJOR}.${LUV_VERSION_MINOR}.${LUV_VERSION_PATCH})
 
 option(BUILD_MODULE "Build as module" ON)
+option(BUILD_STATIC_LIBS "Build static library" OFF)
 option(BUILD_SHARED_LIBS "Build shared library" OFF)
 option(WITH_SHARED_LIBUV "Link to a shared libuv library instead of static linking" OFF)
 
@@ -131,13 +132,20 @@
 if (BUILD_MODULE)
   add_library(luv MODULE src/luv.c)
   set_target_properties(luv PROPERTIES PREFIX "")
-else (BUILD_MODULE)
-  add_library(luv src/luv.c)
-  if (BUILD_SHARED_LIBS)
-    set_target_properties(luv
-      PROPERTIES VERSION ${LUV_VERSION} SOVERSION ${LUV_VERSION_MAJOR})
-  endif (BUILD_SHARED_LIBS)
+  list(APPEND ACTIVE_TARGETS "luv")
 endif (BUILD_MODULE)
+if (BUILD_STATIC_LIBS)
+  add_library(libluv_a STATIC src/luv.c)
+  set_target_properties(libluv_a PROPERTIES PREFIX "")
+  list(APPEND ACTIVE_TARGETS "libluv_a")
+endif (BUILD_STATIC_LIBS)
+if (BUILD_SHARED_LIBS)
+  add_library(libluv SHARED src/luv.c)
+  set_target_properties(libluv PROPERTIES PREFIX "")
+  set_target_properties(libluv
+    PROPERTIES VERSION ${LUV_VERSION} SOVERSION ${LUV_VERSION_MAJOR})
+  list(APPEND ACTIVE_TARGETS "libluv")
+endif (BUILD_SHARED_LIBS)
 
 if(APPLE)
   set(CMAKE_SHARED_MODULE_CREATE_C_FLAGS
@@ -155,61 +163,100 @@
 if(DEFINED ENV{LUA_COMPAT53_DIR})
   set(LUA_COMPAT53_DIR $ENV{LUA_COMPAT53_DIR})
 endif()
-include_directories(${LUA_COMPAT53_DIR})
+include_directories(${LUA_COMPAT53_DIR}/c-api)
 
 if(WIN32)
   add_definitions(-DLUA_BUILD_AS_DLL -DLUA_LIB)
-  if (LUA)
-    target_link_libraries(luv ${LIBUV_LIBRARIES} ${LUA_LIBRARIES})
-  else (LUA)
-    if (USE_LUAJIT)
-      target_link_libraries(luv ${LIBUV_LIBRARIES} ${LUAJIT_LIBRARIES})
-    else (USE_LUAJIT)
-      if (LUA_BUILD_TYPE STREQUAL System)
-          target_link_libraries(luv ${LIBUV_LIBRARIES} ${LUA_LIBRARIES})
-      else (LUA_BUILD_TYPE STREQUAL System)
-          target_link_libraries(luv ${LIBUV_LIBRARIES} lualib)
-      endif (LUA_BUILD_TYPE STREQUAL System)
-    endif (USE_LUAJIT)
-  endif (LUA)
-elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
-  target_link_libraries(luv ${LIBUV_LIBRARIES} rt)
-else()
-  target_link_libraries(luv ${LIBUV_LIBRARIES})
-endif()
+endif()
+
+foreach(TARGET_NAME ${ACTIVE_TARGETS})
+  if(WIN32)
+    if (LUA)
+      target_link_libraries(${TARGET_NAME} ${LIBUV_LIBRARIES} ${LUA_LIBRARIES})
+    else (LUA)
+      if (USE_LUAJIT)
+        target_link_libraries(${TARGET_NAME} ${LIBUV_LIBRARIES} ${LUAJIT_LIBRARIES})
+      else (USE_LUAJIT)
+        if (LUA_BUILD_TYPE STREQUAL System)
+            target_link_libraries(${TARGET_NAME} ${LIBUV_LIBRARIES} ${LUA_LIBRARIES})
+        else (LUA_BUILD_TYPE STREQUAL System)
+            target_link_libraries(${TARGET_NAME} ${LIBUV_LIBRARIES} lualib)
+        endif (LUA_BUILD_TYPE STREQUAL System)
+      endif (USE_LUAJIT)
+    endif (LUA)
+  elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
+    target_link_libraries(${TARGET_NAME} ${LIBUV_LIBRARIES} rt)
+  else()
+    target_link_libraries(${TARGET_NAME} ${LIBUV_LIBRARIES})
+  endif()
+endforeach()
 
 if (NOT LUA)
   if (BUILD_MODULE)
     if (WIN32)
-      set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
+      set(MODULE_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib")
     else (WIN32)
-      set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib/lua/${LUA_VERSION_MAJOR}.${LUA_VERSION_MINOR}")
+      set(MODULE_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib/lua/${LUA_VERSION_MAJOR}.${LUA_VERSION_MINOR}")
     endif (WIN32)
-  else (BUILD_MODULE)
-    set(INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
-      CACHE PATH "Installation directory for libraries")
-    set(INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include/luv"
-      CACHE PATH "Installation directory for headers")
   endif (BUILD_MODULE)
+  if (BUILD_STATIC_LIBS)
+    set(STATICLIBS_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
+      CACHE PATH "Installation directory for static libraries")
+  endif (BUILD_STATIC_LIBS)
+  if (BUILD_SHARED_LIBS)
+    set(SHAREDLIBS_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
+      CACHE PATH "Installation directory for shared libraries")
+  endif (BUILD_SHARED_LIBS)
+else ()
+  # use paths from luaRocks
+  set(MODULE_INSTALL_LIB_DIR "${INSTALL_LIB_DIR}")
+  set(STATICLIBS_INSTALL_LIB_DIR "${INSTALL_LIB_DIR}")
+  set(SHAREDLIBS_INSTALL_LIB_DIR "${INSTALL_LIB_DIR}")
 endif ()
 
+# header install paths are LuaRocks-agnostic, so just use CMAKE_INSTALL_PREFIX regardless
+if (BUILD_STATIC_LIBS)
+  set(STATICLIBS_INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include/luv"
+    CACHE PATH "Installation directory for headers")
+endif (BUILD_STATIC_LIBS)
+if (BUILD_SHARED_LIBS)
+  set(SHAREDLIBS_INSTALL_INC_DIR "${CMAKE_INSTALL_PREFIX}/include/luv"
+    CACHE PATH "Installation directory for headers")
+endif (BUILD_SHARED_LIBS)
+
 if (CMAKE_INSTALL_PREFIX)
-  install(TARGETS luv
-    ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
-    LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
-  )
-  if (NOT BUILD_MODULE)
+  if (BUILD_MODULE)
+    install(TARGETS luv
+      ARCHIVE DESTINATION "${MODULE_INSTALL_LIB_DIR}"
+      LIBRARY DESTINATION "${MODULE_INSTALL_LIB_DIR}"
+    )
+  endif (BUILD_MODULE)
+  if (BUILD_STATIC_LIBS)
+    install(TARGETS libluv_a
+      ARCHIVE DESTINATION "${STATICLIBS_INSTALL_LIB_DIR}"
+      LIBRARY DESTINATION "${STATICLIBS_INSTALL_LIB_DIR}"
+    )
+    install(
+      FILES src/luv.h src/util.h src/lhandle.h src/lreq.h
+      DESTINATION "${STATICLIBS_INSTALL_INC_DIR}"
+    )
+  endif (BUILD_STATIC_LIBS)
+  if (BUILD_SHARED_LIBS)
+    install(TARGETS libluv
+      ARCHIVE DESTINATION "${SHAREDLIBS_INSTALL_LIB_DIR}"
+      LIBRARY DESTINATION "${SHAREDLIBS_INSTALL_LIB_DIR}"
+    )
     if(UNIX)
       set(prefix ${CMAKE_INSTALL_PREFIX})
-      set(includedir ${INSTALL_INC_DIR})
-      set(libdir ${INSTALL_LIB_DIR})
+      set(includedir ${SHAREDLIBS_INSTALL_INC_DIR})
+      set(libdir ${SHAREDLIBS_INSTALL_LIB_DIR})
       configure_file(libluv.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libluv.pc @ONLY)
       install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libluv.pc
-        DESTINATION ${INSTALL_LIB_DIR}/pkgconfig)
+        DESTINATION ${SHAREDLIBS_INSTALL_LIB_DIR}/pkgconfig)
     endif()
     install(
       FILES src/luv.h src/util.h src/lhandle.h src/lreq.h
-      DESTINATION "${INSTALL_INC_DIR}"
-    )
-  endif (NOT BUILD_MODULE)
+      DESTINATION "${SHAREDLIBS_INSTALL_INC_DIR}"
+    )
+  endif (BUILD_SHARED_LIBS)
 endif (CMAKE_INSTALL_PREFIX)

=== Makefile ===
--- 
+++ 
@@ -10,11 +10,14 @@
 WITH_LUA_ENGINE ?= LuaJIT
 LUA_BUILD_TYPE ?= Static
 LUA_COMPAT53_DIR ?= deps/lua-compat-5.3
+BUILD_DIR ?= build
+# options: Release, Debug, RelWithDebInfo, MinSizeRel
+BUILD_TYPE ?= RelWithDebInfo
 
 ifeq ($(WITH_LUA_ENGINE), LuaJIT)
-  LUABIN=build/luajit
+  LUABIN=$(BUILD_DIR)/luajit
 else
-  LUABIN=build/lua
+  LUABIN=$(BUILD_DIR)/lua
 endif
 
 CMAKE_OPTIONS += \
@@ -23,7 +26,8 @@
 	-DWITH_SHARED_LIBUV=$(WITH_SHARED_LIBUV) \
 	-DWITH_LUA_ENGINE=$(WITH_LUA_ENGINE) \
 	-DLUA_BUILD_TYPE=$(LUA_BUILD_TYPE) \
-	-DLUA_COMPAT53_DIR=$(LUA_COMPAT53_DIR)
+	-DLUA_COMPAT53_DIR=$(LUA_COMPAT53_DIR) \
+	-DCMAKE_BUILD_TYPE=$(BUILD_TYPE)
 
 ifeq ($(MAKE),mingw32-make)
 CMAKE_OPTIONS += -G"MinGW Makefiles"
@@ -45,18 +49,18 @@
 deps/lua-compat-5.3/c-api:
 	git submodule update --init deps/lua-compat-5.3
 
-build/Makefile: deps/libuv/include deps/luajit/src deps/lua-compat-5.3/c-api
-	cmake -H. -Bbuild ${CMAKE_OPTIONS}
+$(BUILD_DIR)/Makefile: deps/libuv/include deps/luajit/src deps/lua-compat-5.3/c-api
+	cmake -H. -B$(BUILD_DIR) ${CMAKE_OPTIONS}
 
-luv: build/Makefile
-	cmake --build build --config Debug
-	$(LUV_CP) build/luv$(LUV_EXT) luv$(LUV_EXT)
+luv: $(BUILD_DIR)/Makefile
+	cmake --build $(BUILD_DIR)
+	$(LUV_CP) $(BUILD_DIR)/luv$(LUV_EXT) luv$(LUV_EXT)
 
 install: luv
-	$(MAKE) -C build install
+	$(MAKE) -C $(BUILD_DIR) install
 
 clean:
-	rm -rf build luv.so
+	rm -rf $(BUILD_DIR) luv$(LUV_EXT)
 
 test: luv
 	${LUABIN} tests/run.lua

## lua-luv 1.36.0-0

=== debian/changelog ===
lua-luv (1.36.0-0-1) unstable; urgency=medium

  * New upstream release
  * Remove fix-compat53-include-path.patch, included upstream.
  * Remove cherry-picked b461b6fa3.patch
  * Stop disabling leaks test, since that is no longer automatically run.
  * copyright: Remove unused Files stanza for deps/uv.cmake, not relevant
    since 1.22.0-0
  * control:
    + Use canonical Vcs-Git URL
  * Declare compliance with Policy 4.5.0
  * Enable hardening build flags
  * Add upstream/metadata file with relevant upstream fields

 -- James McCoy <jamessan@debian.org>  Tue, 26 May 2020 22:30:56 -0400

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
                lua-compat53-dev,
                libuv1-dev,
                libkvm-dev [kfreebsd-any]
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Section: interpreters
 Rules-Requires-Root: no
 Homepage: https://github.com/luvit/luv
-Vcs-Git: https://salsa.debian.org/lua-team/lua-luv
+Vcs-Git: https://salsa.debian.org/lua-team/lua-luv.git
 Vcs-Browser: https://salsa.debian.org/lua-team/lua-luv
 
 Package: lua-luv
@@ -21,7 +21,7 @@
 Provides: ${lua:Provides}
 Multi-Arch: same
 XB-Lua-Versions: ${lua:Versions}
-Description: libuv bindings for lua
+Description: libuv bindings for Lua
  libuv is a multi-platform support library with a focus on asynchronous I/O.
  .
  This package provides libuv bindings for the Lua programming language.
@@ -34,5 +34,5 @@
 Provides: ${lua:Provides}
 Multi-Arch: same
 XB-Lua-Versions: ${lua:Versions}
-Description: libuv bindings for lua
- This package provide the static library for lua-luv
+Description: libuv bindings for Lua (development files)
+ This package provide the static library and headers for lua-luv

## lua-luv 1.44.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,9 +7,14 @@
 project (luv C ASM)
 
 set(LUV_VERSION_MAJOR 1)
-set(LUV_VERSION_MINOR 36)
-set(LUV_VERSION_PATCH 0)
+set(LUV_VERSION_MINOR 44)
+set(LUV_VERSION_PATCH 2)
 set(LUV_VERSION ${LUV_VERSION_MAJOR}.${LUV_VERSION_MINOR}.${LUV_VERSION_PATCH})
+
+if(NOT ${CMAKE_VERSION} VERSION_LESS "3.5.0")
+    # generate compilation database used by C code intelligence tools
+  set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+endif()
 
 option(BUILD_MODULE "Build as module" ON)
 option(BUILD_STATIC_LIBS "Build static library" OFF)
@@ -76,6 +81,7 @@
   MESSAGE(STATUS "Lua: using information from luarocks")
 
   MESSAGE(STATUS "LUA_LIBDIR: " ${LUA_LIBDIR})
+  MESSAGE(STATUS "LUA_LIBFILE: " ${LUA_LIBFILE})
   MESSAGE(STATUS "LUA_INCDIR: " ${LUA_INCDIR})
   MESSAGE(STATUS "LUA: " ${LUA})
 
@@ -86,29 +92,59 @@
 
   SET(INSTALL_LIB_DIR ${LIBDIR})
 
-  GET_FILENAME_COMPONENT(LUA_EXEC_NAME ${LUA_EXECUTABLE} NAME_WE)
-  IF(LUA_EXEC_NAME STREQUAL "luajit")
-  FIND_LIBRARY(LUA_LIBRARIES
-    NAMES luajit libluajit
-    PATHS ${LUA_LIBDIR}
-    NO_DEFAULT_PATH)
-  ELSEIF(LUA_EXEC_NAME MATCHES "lua.*")
-    FIND_LIBRARY(LUA_LIBRARIES
-      NAMES lua lua53 lua52 lua51 liblua liblua53 liblua52 liblua51
-      PATHS ${LUA_LIBDIR}
-      NO_DEFAULT_PATH)
-  ENDIF()
-  MESSAGE(STATUS "Lua library: ${LUA_LIBRARIES}")
+  if (LUA_LIBDIR)
+    if (NOT LUA_LIBFILE)
+      # If LIBDIR is set but LIBFILE is not, then that means
+      # Luarocks 2.x is being used, and we'll need to find the lib
+      # ourselves
+      GET_FILENAME_COMPONENT(LUA_EXEC_NAME ${LUA_EXECUTABLE} NAME_WE)
+      IF(LUA_EXEC_NAME STREQUAL "luajit")
+      FIND_LIBRARY(LUA_LIBRARIES
+        NAMES luajit libluajit
+        PATHS ${LUA_LIBDIR}
+        NO_DEFAULT_PATH)
+      ELSEIF(LUA_EXEC_NAME MATCHES "lua.*")
+        FIND_LIBRARY(LUA_LIBRARIES
+          NAMES lua lua54 lua53 lua52 lua51 liblua liblua54 liblua53 liblua52 liblua51
+          PATHS ${LUA_LIBDIR}
+          NO_DEFAULT_PATH)
+      ENDIF()
+    else()
+      # Otherwise, we can just use the LIBFILE that Luarocks provides
+      get_filename_component(LUA_LIBRARIES "${LUA_LIBDIR}/${LUA_LIBFILE}" ABSOLUTE)
+    endif()
+    MESSAGE(STATUS "Lua library: ${LUA_LIBRARIES}")
+  else()
+    MESSAGE(STATUS "Lua library not set, presuming LuaRocks config has link_lua_explicitly set to false")
+  endif()
 
   include_directories(${LUA_INCLUDE_DIR})
 else (LUA)
   if (LUA_BUILD_TYPE STREQUAL System)
     if (USE_LUAJIT)
-      find_package(LuaJIT REQUIRED)
+      # We only link the libs on Windows, so find_package fully succeeding
+      # is only required on Windows
+      if (WIN32 OR CYGWIN)
+        find_package(LuaJIT REQUIRED)
+        link_directories(${LUAJIT_LIBRARIES})
+      else()
+        find_package(LuaJIT)
+      endif()
+      if(NOT LUAJIT_INCLUDE_DIR)
+        message( FATAL_ERROR "Failed to find LuaJIT headers. Variable `LUAJIT_INCLUDE_DIR' expected to be defined.")
+      endif()
       include_directories(${LUAJIT_INCLUDE_DIR})
-      link_directories(${LUAJIT_LIBRARIES})
     else (USE_LUAJIT)
-      find_package(Lua REQUIRED)
+      # We only link the libs on Windows, so find_package fully succeeding
+      # is only required on Windows
+      if (WIN32 OR CYGWIN)
+        find_package(Lua REQUIRED)
+      else()
+        find_package(Lua)
+      endif()
+      if(NOT LUA_INCLUDE_DIR)
+        message( FATAL_ERROR "Failed to find Lua headers. Variable `LUA_INCLUDE_DIR' expected to be defined.")
+      endif()
       include_directories(${LUA_INCLUDE_DIR})
     endif (USE_LUAJIT)
 
@@ -120,14 +156,49 @@
     endif (LUA_BUILD_TYPE STREQUAL Static)
     if (USE_LUAJIT)
       include(deps/luajit.cmake)
-      include_directories(deps/luajit/src)
+      set(LUA_INCLUDE_DIR deps/luajit/src)
       set(LUAJIT_LIBRARIES luajit-5.1)
     else(USE_LUAJIT)
       include(deps/lua.cmake)
-      include_directories(deps/lua)
+      set(LUA_INCLUDE_DIR deps/lua)
     endif (USE_LUAJIT)
+    include_directories(${LUA_INCLUDE_DIR})
+    set(LUA_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/${LUA_INCLUDE_DIR})
   endif (LUA_BUILD_TYPE STREQUAL System)
 endif (LUA)
+
+if (EXISTS "${LUA_INCLUDE_DIR}/lua.h")
+    # At least 5.[012] have different ways to express the version
+    # so all of them need to be tested. Lua 5.2 defines LUA_VERSION
+    # and LUA_RELEASE as joined by the C preprocessor, so avoid those.
+
+    # lua 5.2 and above
+    file(STRINGS "${LUA_INCLUDE_DIR}/lua.h" LUA_VERSION_MAJOR
+         REGEX "^#define[ \t]+LUA_VERSION_MAJOR[ \t]+\"Lua [0-9]+")
+    file(STRINGS "${LUA_INCLUDE_DIR}/lua.h" LUA_VERSION_MINOR
+         REGEX "^#define[ \t]+LUA_VERSION_MINOR[ \t]+\"Lua [0-9]+")
+
+    if(NOT LUA_VERSION_MAJOR AND NOT LUA_VERSION_MINOR)
+      file(STRINGS "${LUA_INCLUDE_DIR}/lua.h" lua_version_strings
+           REGEX "^#define[ \t]+LUA_VERSION([ \t]+\"Lua [0-9]|_[MR]).*")
+      string(REGEX REPLACE ".*;#define[ \t]+LUA_VERSION_MAJOR[ \t]+\"([0-9])\"[ \t]*;.*" "\\1" LUA_VERSION_MAJOR ";${lua_version_strings};")
+      if (LUA_VERSION_MAJOR MATCHES "^[0-9]+$")
+          string(REGEX REPLACE ".*;#define[ \t]+LUA_VERSION_MINOR[ \t]+\"([0-9])\"[ \t]*;.*" "\\1" LUA_VERSION_MINOR ";${lua_version_strings};")
+          string(REGEX REPLACE ".*;#define[ \t]+LUA_VERSION_RELEASE[ \t]+\"([0-9])\"[ \t]*;.*" "\\1" LUA_VERSION_PATCH ";${lua_version_strings};")
+          set(LUA_VERSION_STRING "${LUA_VERSION_MAJOR}.${LUA_VERSION_MINOR}.${LUA_VERSION_PATCH}")
+      else ()
+          string(REGEX REPLACE ".*;#define[ \t]+LUA_RELEASE[ \t]+\"Lua ([0-9.]+)\"[ \t]*;.*" "\\1" LUA_VERSION_STRING ";${lua_version_strings};")
+          if (NOT LUA_VERSION_STRING MATCHES "^[0-9.]+$")
+              string(REGEX REPLACE ".*;#define[ \t]+LUA_VERSION[ \t]+\"Lua ([0-9.]+)\"[ \t]*;.*" "\\1" LUA_VERSION_STRING ";${lua_version_strings};")
+          endif ()
+          string(REGEX REPLACE "^([0-9]+)\\.[0-9.]*$" "\\1" LUA_VERSION_MAJOR "${LUA_VERSION_STRING}")
+          string(REGEX REPLACE "^[0-9]+\\.([0-9]+)[0-9.]*$" "\\1" LUA_VERSION_MINOR "${LUA_VERSION_STRING}")
+          string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]).*" "\\1" LUA_VERSION_PATCH "${LUA_VERSION_STRING}")
+      endif ()
+
+      unset(lua_version_strings)
+    endif()
+endif()
 
 if (BUILD_MODULE)
   add_library(luv MODULE src/luv.c)
@@ -136,14 +207,17 @@
 endif (BUILD_MODULE)
 if (BUILD_STATIC_LIBS)
   add_library(libluv_a STATIC src/luv.c)
-  set_target_properties(libluv_a PROPERTIES PREFIX "")
+  set_target_properties(libluv_a PROPERTIES OUTPUT_NAME luv)
   list(APPEND ACTIVE_TARGETS "libluv_a")
 endif (BUILD_STATIC_LIBS)
 if (BUILD_SHARED_LIBS)
   add_library(libluv SHARED src/luv.c)
-  set_target_properties(libluv PROPERTIES PREFIX "")
   set_target_properties(libluv
-    PROPERTIES VERSION ${LUV_VERSION} SOVERSION ${LUV_VERSION_MAJOR})
+    PROPERTIES VERSION ${LUV_VERSION} SOVERSION ${LUV_VERSION_MAJOR} OUTPUT_NAME luv)
+  if(APPLE)
+    set_target_properties(libluv
+      PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
+  endif(APPLE)
   list(APPEND ACTIVE_TARGETS "libluv")
 endif (BUILD_SHARED_LIBS)
 
@@ -170,7 +244,7 @@
 endif()
 
 foreach(TARGET_NAME ${ACTIVE_TARGETS})
-  if(WIN32)
+  if(WIN32 OR CYGWIN)
     if (LUA)
       target_link_libraries(${TARGET_NAME} ${LIBUV_LIBRARIES} ${LUA_LIBRARIES})
     else (LUA)
@@ -204,6 +278,8 @@
       CACHE PATH "Installation directory for static libraries")
   endif (BUILD_STATIC_LIBS)
   if (BUILD_SHARED_LIBS)
+    set(SHAREDLIBS_INSTALL_BIN_DIR "${CMAKE_INSTALL_PREFIX}/bin"
+      CACHE PATH "Installation directory for runtime components")
     set(SHAREDLIBS_INSTALL_LIB_DIR "${CMAKE_INSTALL_PREFIX}/lib"
       CACHE PATH "Installation directory for shared libraries")
   endif (BUILD_SHARED_LIBS)
@@ -243,20 +319,8 @@
   endif (BUILD_STATIC_LIBS)
   if (BUILD_SHARED_LIBS)
     install(TARGETS libluv
+      RUNTIME DESTINATION "${SHAREDLIBS_INSTALL_BIN_DIR}"
       ARCHIVE DESTINATION "${SHAREDLIBS_INSTALL_LIB_DIR}"
       LIBRARY DESTINATION "${SHAREDLIBS_INSTALL_LIB_DIR}"
     )
-    if(UNIX)
-      set(prefix ${CMAKE_INSTALL_PREFIX})
-      set(includedir ${SHAREDLIBS_INSTALL_INC_DIR})
-      set(libdir ${SHAREDLIBS_INSTALL_LIB_DIR})
-      configure_file(libluv.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libluv.pc @ONLY)
-      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libluv.pc
-        DESTINATION ${SHAREDLIBS_INSTALL_LIB_DIR}/pkgconfig)
-    endif()
-    install(
-      FILES src/luv.h src/util.h src/lhandle.h src/lreq.h
-      DESTINATION "${SHAREDLIBS_INSTALL_INC_DIR}"
-    )
-  endif (BUILD_SHARED_LIBS)
-endif (CMAKE_INSTALL_PREFIX)
+    if(UNIX OR MINGW)

=== Makefile ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 BUILD_MODULE ?= ON
 BUILD_SHARED_LIBS ?= OFF
+BUILD_STATIC_LIBS ?= OFF
 WITH_SHARED_LIBUV ?= OFF
 WITH_LUA_ENGINE ?= LuaJIT
 LUA_BUILD_TYPE ?= Static
@@ -23,6 +24,7 @@
 CMAKE_OPTIONS += \
 	-DBUILD_MODULE=$(BUILD_MODULE) \
 	-DBUILD_SHARED_LIBS=$(BUILD_SHARED_LIBS) \
+	-DBUILD_STATIC_LIBS=$(BUILD_STATIC_LIBS) \
 	-DWITH_SHARED_LIBUV=$(WITH_SHARED_LIBUV) \
 	-DWITH_LUA_ENGINE=$(WITH_LUA_ENGINE) \
 	-DLUA_BUILD_TYPE=$(LUA_BUILD_TYPE) \

## lua-luv 1.44.2-0

=== debian/changelog ===
lua-luv (1.44.2-0-1deepin1) unstable; urgency=medium

  * Add minimum dh_lua version limit 

 -- xiangzelong <xiangzelong@deepin.org>  Thu, 27 Apr 2023 15:36:54 +0800

lua-luv (1.44.2-0-1) unstable; urgency=medium

  * New upstream release
  * Set Forwarded: not-needed for disable_some_tests.patch
  * Declare compliance with Policy 4.6.1, no changes needed
  * Set Lua Team as maintainer, myself as an Uploader

 -- James McCoy <jamessan@debian.org>  Fri, 05 Aug 2022 20:44:57 -0400

lua-luv (1.43.0-0-2) unstable; urgency=medium

  * Add allow-stderr restriction for autopkgtests

 -- James McCoy <jamessan@debian.org>  Sun, 27 Feb 2022 21:02:11 -0500

lua-luv (1.43.0-0-1) unstable; urgency=medium

  * New upstream release
  * Add Lua 5.4 support
  * Declare compliance with Policy 4.6.0, no changes needed
  * Remove explicit libkvm-dev Build-Depends now that libuv1-dev added it

 -- James McCoy <jamessan@debian.org>  Sun, 27 Feb 2022 11:41:55 -0500

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: lua-luv
 Priority: optional
-Maintainer: Jason Pleau <jason@jpleau.ca>
-Uploaders: James McCoy <jamessan@debian.org>
+Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Uploaders:
+ Jason Pleau <jason@jpleau.ca>,
+ James McCoy <jamessan@debian.org>,
 Build-Depends: debhelper-compat (= 12),
-               dh-lua,
+               dh-lua (>= 28),
                lua-compat53-dev,
                libuv1-dev,
-               libkvm-dev [kfreebsd-any]
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Section: interpreters
 Rules-Requires-Root: no
 Homepage: https://github.com/luvit/luv

## lua-luv 1.48.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,10 @@
-cmake_minimum_required(VERSION 2.8)
-
-if(POLICY CMP0053)
-  cmake_policy(SET CMP0053 NEW) # faster evaluation of variable references
-endif()
+cmake_minimum_required(VERSION 3.5)
 
 project (luv C ASM)
 
 set(LUV_VERSION_MAJOR 1)
-set(LUV_VERSION_MINOR 44)
-set(LUV_VERSION_PATCH 2)
+set(LUV_VERSION_MINOR 48)
+set(LUV_VERSION_PATCH 0)
 set(LUV_VERSION ${LUV_VERSION_MAJOR}.${LUV_VERSION_MINOR}.${LUV_VERSION_PATCH})
 
 if(NOT ${CMAKE_VERSION} VERSION_LESS "3.5.0")
@@ -324,3 +320,5 @@
       LIBRARY DESTINATION "${SHAREDLIBS_INSTALL_LIB_DIR}"
     )
     if(UNIX OR MINGW)
+      set(prefix ${CMAKE_INSTALL_PREFIX})
+      set(includedir ${SHAREDLIBS_INSTALL_INC_DIR})

=== Makefile ===
--- 
+++ 
@@ -30,6 +30,10 @@
 	-DLUA_BUILD_TYPE=$(LUA_BUILD_TYPE) \
 	-DLUA_COMPAT53_DIR=$(LUA_COMPAT53_DIR) \
 	-DCMAKE_BUILD_TYPE=$(BUILD_TYPE)
+
+ifdef INSTALL_PREFIX
+CMAKE_OPTIONS += -DCMAKE_INSTALL_PREFIX=$(INSTALL_PREFIX)
+endif
 
 ifeq ($(MAKE),mingw32-make)
 CMAKE_OPTIONS += -G"MinGW Makefiles"

## lua-luv 1.48.0-2

=== debian/changelog ===
lua-luv (1.48.0-2-4) unstable; urgency=medium

  * Team upload
  * Drop lua5.2 support

 -- Bastian Germann <bage@debian.org>  Thu, 09 Oct 2025 11:54:33 +0200

lua-luv (1.48.0-2-3) unstable; urgency=medium

  * Add patch to increase timeout for async callback in "test threadpool with
    async" test (Closes: #1079983)
  * Bump debhelper-compat to 13
  * Declare compliance with Policy 4.7.0, no changes needed

 -- James McCoy <jamessan@debian.org>  Sat, 31 Aug 2024 21:34:03 -0400

lua-luv (1.48.0-2-2) unstable; urgency=medium

  * Set VERSION_INFO=1:0:0 to align with upstream sover
  * Break neovim << 0.9.5-5
  * Declare compliance with Policy 4.6.2, no changes needed

 -- James McCoy <jamessan@debian.org>  Sun, 03 Mar 2024 16:20:14 -0500

lua-luv (1.48.0-2-1) unstable; urgency=medium

  * New upstream release
  * Build-Depend against dpkg-dev >= 1.22.5 for the t64 transition
    (Closes: #1063254)
  * Disable loop tests since they fail with dh-lua's app-dynamic test cycle.

 -- James McCoy <jamessan@debian.org>  Sat, 02 Mar 2024 20:24:41 -0500

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_install:
# Do not install usr/include/lua{luaver}/luv.h, since all the headers get
# installed to usr/include/lua{luaver}/luv/
	sed -i '/usr\/include\/lua5\.[1-9]\/luv\.h/d' debian/lua-luv-dev.install
	dh_auto_install
# Remove usr/include/lua{luaver}/luv.h, so dh_missing doesn't complain
	rm -f debian/tmp/usr/include/lua*/luv.h

=== debian/watch ===
version=3
opts=uversionmangle=s/\.(RC|rc|pre|dev|beta|alpha)/~$1/,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/lua-luv-$1\.tar\.gz/ \
https://github.com/luvit/luv/tags .*/v?(\d\S*)\.tar\.gz

## lua-luv 1.51.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
 project (luv C ASM)
 
 set(LUV_VERSION_MAJOR 1)
-set(LUV_VERSION_MINOR 48)
+set(LUV_VERSION_MINOR 51)
 set(LUV_VERSION_PATCH 0)
 set(LUV_VERSION ${LUV_VERSION_MAJOR}.${LUV_VERSION_MINOR}.${LUV_VERSION_PATCH})
 
@@ -44,7 +44,7 @@
 
 if (NOT LUA_BUILD_TYPE)
   set(LUA_BUILD_TYPE "Static"
-    CACHE STRING "Build Lua/LuaJIT as static, dynamic libary, or use system one" FORCE)
+    CACHE STRING "Build Lua/LuaJIT as static, dynamic library, or use system one" FORCE)
   set_property(CACHE LUA_BUILD_TYPE
     PROPERTY STRINGS  "Static;Dynamic;System")
 endif (NOT LUA_BUILD_TYPE)
@@ -157,6 +157,7 @@
     else(USE_LUAJIT)
       include(deps/lua.cmake)
       set(LUA_INCLUDE_DIR deps/lua)
+      set(LUA_LIBRARIES lualib)
     endif (USE_LUAJIT)
     include_directories(${LUA_INCLUDE_DIR})
     set(LUA_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/${LUA_INCLUDE_DIR})
@@ -238,6 +239,17 @@
 if(WIN32)
   add_definitions(-DLUA_BUILD_AS_DLL -DLUA_LIB)
 endif()
+
+add_executable(test EXCLUDE_FROM_ALL src/test.c src/luv.c)
+# Need to link Lua/LuaJIT libraries on non-Windows for the test executable
+if ((LUAJIT_LIBRARIES OR LUA_LIBRARIES) AND NOT (WIN32 OR CYGWIN))
+  if(USE_LUAJIT)
+    target_link_libraries(test ${LUAJIT_LIBRARIES})
+  else()
+    target_link_libraries(test ${LUA_LIBRARIES})
+  endif()
+endif()
+list(APPEND ACTIVE_TARGETS "test")
 
 foreach(TARGET_NAME ${ACTIVE_TARGETS})
   if(WIN32 OR CYGWIN)
@@ -311,14 +323,3 @@
     install(
       FILES src/luv.h src/util.h src/lhandle.h src/lreq.h
       DESTINATION "${STATICLIBS_INSTALL_INC_DIR}"
-    )
-  endif (BUILD_STATIC_LIBS)
-  if (BUILD_SHARED_LIBS)
-    install(TARGETS libluv
-      RUNTIME DESTINATION "${SHAREDLIBS_INSTALL_BIN_DIR}"
-      ARCHIVE DESTINATION "${SHAREDLIBS_INSTALL_LIB_DIR}"
-      LIBRARY DESTINATION "${SHAREDLIBS_INSTALL_LIB_DIR}"
-    )
-    if(UNIX OR MINGW)
-      set(prefix ${CMAKE_INSTALL_PREFIX})
-      set(includedir ${SHAREDLIBS_INSTALL_INC_DIR})

=== Makefile ===
--- 
+++ 
@@ -70,6 +70,8 @@
 
 test: luv
 	${LUABIN} tests/run.lua
+	$(MAKE) -C $(BUILD_DIR) test
+	$(BUILD_DIR)/test tests/manual-test-external-loop.lua
 
 reset:
 	git submodule update --init --recursive && \

## lua-luv 1.51.0-1

=== debian/changelog ===
lua-luv (1.51.0-1-1) unstable; urgency=medium

  * New upstream release
  * Declare compliance with Policy 4.7.2, no changes needed
  * Update path to docs.md
  * Remove "Rules-Require-Root: no", since it is now default
  * Add Salsa CI config

 -- James McCoy <jamessan@debian.org>  Thu, 30 Oct 2025 11:46:17 -0400

=== debian/control ===
Source: lua-luv
Priority: optional
Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
Uploaders:
 Jason Pleau <jason@jpleau.ca>,
 James McCoy <jamessan@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-lua,
 dpkg-dev (>= 1.22.5),
 libuv1-dev,
 lua-compat53-dev,
Standards-Version: 4.7.2
Section: interpreters
Homepage: https://github.com/luvit/luv
Vcs-Git: https://salsa.debian.org/lua-team/lua-luv.git
Vcs-Browser: https://salsa.debian.org/lua-team/lua-luv

Package: lua-luv
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 ${lua:Provides},
Breaks:
 neovim (<< 0.9.5-5~),
Multi-Arch: same
XB-Lua-Versions: ${lua:Versions}
Description: libuv bindings for Lua
 libuv is a multi-platform support library with a focus on asynchronous I/O.
 .
 This package provides libuv bindings for the Lua programming language.

Package: lua-luv-dev
Section: libdevel
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libuv1-dev,
 lua-luv (= ${binary:Version}),
 ${misc:Depends},
Provides:
 ${lua:Provides},
Multi-Arch: same
XB-Lua-Versions: ${lua:Versions}
Description: libuv bindings for Lua (development files)
 This package provide the static library and headers for lua-luv
